package pr_x;
import java.sql.*;
//import com.imaginary.sql.msql.*;
import java.net.URL;
import java.util.*;

public class DB {
    static DB db;

    static final String[]
       keys={"select","update","insert","delete",    // 0 - 3
             "close","create","open","change",       // 4 - 7
             "jdbc","UNKNOWN CMD"};

    static Connection con;      //<<<<<<<<<
    static Statement  stmt;     //<<<<<<<<<
    static ResultSet  result;   //<<<<<<<<<

    public static void close() throws SQLException{ con.close(); }

    public static ResultSet select(String cmd) {
        try { result = stmt.executeQuery(cmd);  //<<<<<<<<<
        } catch (SQLException e) { e.printStackTrace(); }
        return result;
    }

    public static void update(String cmd) {
        try {stmt.executeUpdate(cmd);   //<<<<<<<<<
        } catch (SQLException e) { e.printStackTrace(); }
    }

    public static String perform(String cmd) {
      try {
        cmd.trim();
        int i;
        for (i = 0; i<keys.length-1; i++)
             if(cmd.toLowerCase().startsWith(keys[i])) break;

        //System.out.println("CMD="+keys[i]+"    "+cmd);

        switch(i) {
           case 0: { return results(cmd); }
           case 1: {}
           case 2: {}
           case 3: { return " code="+stmt.executeUpdate(cmd); }
           case 4: {}
           case 5: { return " code="+stmt.executeUpdate(cmd); }
           case 6: { break; }
           case 7: { break; }
           case 8: { return connectDB(cmd); }
           default:{ if (cmd.endsWith("Driver")) {
                        //System.out.println("DRIVER REQ="+cmd);
                        return connectDriver(cmd);
                     }
                     else {return keys[9];}
           }
        }
      } catch(Exception ex) { return ex.toString();}
        return "*****";
    }

    public static String connectDB(String cmd) {
       String s="Database=";
       try {
         System.out.println("     Connection through DriverManager to "+cmd);
         con = DriverManager.getConnection(cmd);  //<<<<<<<<<
         System.out.println("     Created connection="+con);
         stmt = con.createStatement();  //<<<<<<<<<
         s+=stmt;
       }
       catch (Exception e) { s+=e.toString(); }
       return s;
    }

    public static String connectDriver(String cmd) {
       String s="     Available drivers:";
       try {
         Class.forName(cmd);  //<<<<<<<<<
         Enumeration k=DriverManager.getDrivers();
         while (k.hasMoreElements()) s=s+"\n  "+k.nextElement();
       }
       catch (Exception e) { s=e.toString(); }
       System.out.println("returns="+s);
       return s;
    }

    public static String results(String cmd) {
       String s="Results:";
       int  i=0;
       try {
           ResultSet rs=stmt.executeQuery(cmd);  //<<<<<<<<<
           ResultSetMetaData rsmd= rs.getMetaData();  //<<<<<<<<<
           int j=rsmd.getColumnCount();  //<<<<<<<<<

           while(rs.next()) {
              i++;
              s+="\n     "+i+"  ";
              for (int k=1; k<=j; k++) s+=rs.getString(k)+", ";
           }
          s=s+"\n     TOTAL="+i;

       }
       catch (Exception e) { s=e.toString(); }
       return s;
    }

}