package pr_x;
import java.awt.*;
import javax.swing.*;
import java.util.*;
import java.awt.event.*;
import java.sql.*;

public class X06_TestJDBC extends JFrame {
  static ResultSet rs;

  //static String  driver="com.imaginary.sql.msql.MsqlDriver";
  static String  driver="org.gjt.mm.mysql.Driver";
  static String  database="jdbc:mysql://localhost:3306/A";
  X08_ClientDB client=new X08_ClientDB();

  static final String[] hints={
     "org.gjt.mm.mysql.Driver    ~    jdbc:mysql://localhost:3306/A",
     "com.imaginary.sql.msql.MsqlDriver    ~   jdbc:msql://localhost:1112/AA",
     "SELECT  *  FROM table",
     "SELECT  *  FROM table WHERE (cond)",
     "INSERT INTO  table  (col) VALUES  ('val')",
     "INSERT INTO  table  (col1, col2) VALUES  ('val1', 'val2')",
     "CREATE TABLE table  (col char(10))",
     "CREATE TABLE table  (col1 char(10), col2 char(10))"
  };

  JPanel panx = new JPanel();
  GridLayout gridLayout1 = new GridLayout();

  CmdLine pan1=new CmdLine("JDBC DRIVER",driver){};
  CmdLine pan2=new CmdLine("DATABASE     ",database){};
  CmdLine pan3=new CmdLine("COMMAND     ",hints[7]);
  CmdLine pan4=new CmdLine("COMMAND     ",hints[5]);
  CmdLine pan5=new CmdLine("COMMAND     ",hints[3]);

  BorderLayout borderLayout1 = new BorderLayout();

  static JTextArea ta = new JTextArea("JDBC TESTER");

  public X06_TestJDBC() {
    try {jbInit(); }
    catch(Exception e) {e.printStackTrace();}
     setSize(600,300);
     setVisible(true);

     JFrame h=new JFrame("Hints");
     JTextArea th=new JTextArea(hints[0],hints.length,40);
     for (int i=1; i<hints.length; i++) th.append("\n"+hints[i]);

     h.getContentPane().add(th);
     h.setLocation(300,100);
     h.pack();
     h.setVisible(true);
  }

  public static void main(String[] args) throws Exception {
    new X06_TestJDBC();
  }

  private void jbInit() throws Exception {
    this.getContentPane().setLayout(borderLayout1);
    panx.setLayout(new GridLayout(5,1));
    panx.setPreferredSize(new Dimension(500, 150));

    ta.setBackground(new Color(217, 243, 184));
    ta.setEditable(false);

    this.getContentPane().add(panx, BorderLayout.NORTH);

    panx.add(pan1, null);
    panx.add(pan2, null);
    panx.add(pan3, null);
    panx.add(pan4, null);
    panx.add(pan5, null);

    this.getContentPane().add(ta, BorderLayout.CENTER);
  }

  /**  */
  void command(ActionEvent e)  {
     String t=((JTextField) (e.getSource())).getText().trim();
     ta.setText(client.provide(t));
  }

  // *****************  inner class  ********************
  class CmdLine extends JPanel implements ActionListener {
    JLabel la=new JLabel("",SwingConstants.RIGHT);
    JTextField tf=new JTextField();

    CmdLine(String txt, String cmd) {
      this.setLayout(new FlowLayout(FlowLayout.LEFT));
      la.setText(txt);
      tf.setPreferredSize(new Dimension(500, 30));
      tf.setText(cmd);
      tf.addActionListener(this);
      add(la);
      add(tf);
    }

    public void actionPerformed(ActionEvent e) { command(e); }
  }
}